/*
 * 机具激活限制信息
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class UserSnActInfoController : BaseController
    {
        public UserSnActInfoController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 机具激活限制信息列表

        /// <summary>
        /// 根据条件查询机具激活限制信息列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(UserSnActInfo data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 根据条件查询机具激活限制信息列表

        /// <summary>
        /// 机具激活限制信息列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(UserSnActInfo data, string UserIdMakerCode, string UserIdRealName, string BrandIdSelect, string SnTypeSelect, string ActiveStatusSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("SnNo", "1"); //SN编号


            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }
            //产品类型
            if (!string.IsNullOrEmpty(BrandIdSelect))
            {
                condition += " and BrandId=" + BrandIdSelect;
            }
            //SN机具类型
            if (!string.IsNullOrEmpty(SnTypeSelect))
            {
                condition += " and SnType=" + SnTypeSelect;
            }
            //商户激活状态
            if (!string.IsNullOrEmpty(ActiveStatusSelect))
            {
                condition += " and ActiveStatus=" + ActiveStatusSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserSnActInfo", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //产品类型
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                //SN机具类型
                int SnType = int.Parse(dic["SnType"].ToString());
                if (SnType == 0) dic["SnType"] = "兑换机具";
                if (SnType == 1) dic["SnType"] = "循环机具";
                //SN仓库
                int SnStoreId = int.Parse(function.CheckInt(dic["SnStoreId"].ToString()));
                StoreHouse snstoreid_StoreHouse = db.StoreHouse.FirstOrDefault(m => m.Id == SnStoreId) ?? new StoreHouse();
                dic["SnStoreIdStoreNo"] = snstoreid_StoreHouse.StoreNo;
                dic["SnStoreIdStoreName"] = snstoreid_StoreHouse.StoreName;
                dic.Remove("SnStoreId");
                //激活奖励创客
                dic["ActUserId"] = RelationClass.GetUsersInfo(int.Parse(dic["ActUserId"].ToString()));
                //商户激活状态
                int ActiveStatus = int.Parse(dic["ActiveStatus"].ToString());
                if (ActiveStatus == 0) dic["ActiveStatus"] = "未激活";
                if (ActiveStatus == 1) dic["ActiveStatus"] = "已激活";
                if (ActiveStatus == 2) dic["ActiveStatus"] = "SN已返现";
                //源SN机具类型
                int SourceSnType = int.Parse(dic["SourceSnType"].ToString());
                if (SourceSnType == 0) dic["SourceSnType"] = "兑换机具";
                if (SourceSnType == 1) dic["SourceSnType"] = "循环机具";
                //源SN发货你仓库
                dic["SourceStoreId"] = RelationClass.GetStoreHouseInfo(int.Parse(dic["SourceStoreId"].ToString()));

            }
            return Json(obj);
        }

        #endregion

        #region 增加机具激活限制信息

        /// <summary>
        /// 增加或修改机具激活限制信息信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加机具激活限制信息

        /// <summary>
        /// 增加或修改机具激活限制信息信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(UserSnActInfo data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("UserSnActInfo", Fields, 0);
            AddSysLog(data.Id.ToString(), "UserSnActInfo", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改机具激活限制信息

        /// <summary>
        /// 增加或修改机具激活限制信息信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            UserSnActInfo editData = db.UserSnActInfo.FirstOrDefault(m => m.Id == Id) ?? new UserSnActInfo();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改机具激活限制信息

        /// <summary>
        /// 增加或修改机具激活限制信息信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(UserSnActInfo data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserSnActInfo", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "UserSnActInfo", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除机具激活限制信息信息

        /// <summary>
        /// 删除机具激活限制信息信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserSnActInfo", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserSnActInfo", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserSnActInfo", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserSnActInfo", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserSnActInfo", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserSnActInfo", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("UserSnActInfo", Sort, Id);

            AddSysLog(Id.ToString(), "UserSnActInfo", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.UserSnActInfo.Add(new UserSnActInfo()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "UserSnActInfo", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(UserSnActInfo data, string UserIdMakerCode, string UserIdRealName, string BrandIdSelect, string SnTypeSelect, string ActiveStatusSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("SnNo", "1"); //SN编号


            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }
            //产品类型
            if (!string.IsNullOrEmpty(BrandIdSelect))
            {
                condition += " and BrandId=" + BrandIdSelect;
            }
            //SN机具类型
            if (!string.IsNullOrEmpty(SnTypeSelect))
            {
                condition += " and SnType=" + SnTypeSelect;
            }
            //商户激活状态
            if (!string.IsNullOrEmpty(ActiveStatusSelect))
            {
                condition += " and ActiveStatus=" + ActiveStatusSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserSnActInfo", Fields, "Id desc", "0", 1, 20000, condition, "UserId,BrandId,SnNo,SnType,SnStoreId,EffectStartCycleDate,EffectEndCycleDate,ActUserId,ActiveStatus,StandardDate,SourceSnNo,SourceSnType,SourceShipDate,SourceStoreId", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //产品类型
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                //SN机具类型
                int SnType = int.Parse(dic["SnType"].ToString());
                if (SnType == 0) dic["SnType"] = "兑换机具";
                if (SnType == 1) dic["SnType"] = "循环机具";
                //SN仓库
                int SnStoreId = int.Parse(function.CheckInt(dic["SnStoreId"].ToString()));
                StoreHouse snstoreid_StoreHouse = db.StoreHouse.FirstOrDefault(m => m.Id == SnStoreId) ?? new StoreHouse();
                dic["SnStoreIdStoreNo"] = snstoreid_StoreHouse.StoreNo;
                dic["SnStoreIdStoreName"] = snstoreid_StoreHouse.StoreName;
                dic.Remove("SnStoreId");
                //激活奖励创客
                dic["ActUserId"] = RelationClass.GetUsersInfo(int.Parse(dic["ActUserId"].ToString()));
                //商户激活状态
                int ActiveStatus = int.Parse(dic["ActiveStatus"].ToString());
                if (ActiveStatus == 0) dic["ActiveStatus"] = "未激活";
                if (ActiveStatus == 1) dic["ActiveStatus"] = "已激活";
                if (ActiveStatus == 2) dic["ActiveStatus"] = "SN已返现";
                //源SN机具类型
                int SourceSnType = int.Parse(dic["SourceSnType"].ToString());
                if (SourceSnType == 0) dic["SourceSnType"] = "兑换机具";
                if (SourceSnType == 1) dic["SourceSnType"] = "循环机具";
                //源SN发货你仓库
                dic["SourceStoreId"] = RelationClass.GetStoreHouseInfo(int.Parse(dic["SourceStoreId"].ToString()));

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("UserIdMakerCode", "创客编号");
            ReturnFields.Add("UserIdRealName", "创客真实姓名");
            ReturnFields.Add("BrandId", "产品类型");
            ReturnFields.Add("SnNo", "SN编号");
            ReturnFields.Add("SnType", "SN机具类型");
            ReturnFields.Add("SnStoreIdStoreNo", "SN仓库编号");
            ReturnFields.Add("SnStoreIdStoreName", "SN仓库名称");
            ReturnFields.Add("EffectStartCycleDate", "有效开始循环时间");
            ReturnFields.Add("EffectEndCycleDate", "有效结束循环时间");
            ReturnFields.Add("ActUserId", "激活奖励创客");
            ReturnFields.Add("ActiveStatus", "商户激活状态");
            ReturnFields.Add("StandardDate", "激活日期");
            ReturnFields.Add("SourceSnNo", "源SN编号");
            ReturnFields.Add("SourceSnType", "源SN机具类型");
            ReturnFields.Add("SourceShipDate", "源SN发货时间");
            ReturnFields.Add("SourceStoreId", "源SN发货你仓库");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "UserSnActInfo", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
